'// Parameters for mail-server: 
'--------------------------------------------------------------------
MailFrom 	= ""	'// Example: max.muster@mailprovider.net
MailTo 		= ""	'// Example: max.muster@mailprovider.net
Username 	= ""	
Password 	= ""	
SmtpServer 	= ""	'// Example: smtp.mailprovider.net
SmtpPort 	= 465 	'// Standard port for encrypted login: e.g. 465, 587
'--------------------------------------------------------------------

'// Dieses Skript sendet eine E-Mail bei einem verpassten Anruf. 
'// -> nur bei Abwesenheit (Prsenzstatus/Lockscreen) und im Zeitfenster von Mo-Fr, 7:00-17:00 Uhr -> siehe Funktionen: InAbsence(), InTimeWindow()

'// This script sends an email on a missed call.
'// -> only in absence (presence status/lockscreen) and in the time window from Mon to Fri, 7:00 a.m. to 5:00 p.m -> see functions: InAbsence(), InTimeWindow()

'// Example of running the script with parameters:
'// missed_call_mail.vbs /Name:"%contact.display%" /Call:"%tel%" /Time:"%call.start%" /LockScreen:"%lockscreen%" /Presence:"%presence%" /Notes:"%notes[500]%"
    
set Params = WScript.Arguments.Named  '// Read named parameters 

SendCallMail()  

'----------------------------------------------------------------------------------------------
Function SendCallMail()
'----------------------------------------------------------------------------------------------
	
	'-- Check conditions for sending this email -------------------------
	
	if WScript.Arguments.Count < 1 then exit function
	
	if NOT CheckMailServerParams() then exit function 	'// Check parameters for mail-server: MailTo, Username, Password, SmtpServer
	
	if NOT InAbsence() then exit function 	'// Send the email only when you are absent (go to the function to edit the conditions)

	if NOT InTimeWindow() then exit function 	'// Send the email only in a specific time window (go to the function to edit the conditions)
			
	'-- Build email text (de/en) ----------------------------------------
	
	if NOT IsLocalDE() then

		Subject = "Verpasster Anruf: " + Params.Item("Call") + ", " + Params.Item("Name")
		
		Body = "Verpasster Anruf:" + vbNewLine
		Body = Body  + "Name/Firma: " + Params.Item("Name") + vbNewLine
		Body = Body  + "Rufnummer: " + Params.Item("Call") + vbNewLine
		Body = Body  + "Zeit: " + Params.Item("Time") + vbNewLine + vbNewLine
		Body = Body  + "Notizen: " + vbNewLine + Params.Item("Notes")

	else

		Subject = "missed call: " + Params.Item("Call") + ", " + Params.Item("Name")
		
		Body = "missed call:" + vbNewLine
		Body = Body  + "name/company: " + Params.Item("Name") + vbNewLine
		Body = Body  + "phone number: " + Params.Item("Call") + vbNewLine
		Body = Body  + "time: " + Params.Item("Time") + vbNewLine + vbNewLine
		Body = Body  + "notes: " + vbNewLine + Params.Item("Notes")

	end if
	
	'-- Send email --------------------------------------------------
	
	Set mailObj      = CreateObject("CDO.Message")
	mailObj.From     = MailFrom
	mailObj.To       = MailTo
	mailObj.Subject  = Subject
	mailObj.TextBody = Body

	Set mailCfg = mailObj.Configuration

	mailCfg.Fields("http://schemas.microsoft.com/cdo/configuration/smtpserver") 		= SmtpServer
	mailCfg.Fields("http://schemas.microsoft.com/cdo/configuration/smtpserverport") 	= SmtpPort
	mailCfg.Fields("http://schemas.microsoft.com/cdo/configuration/sendusing")    		= 2  
	mailCfg.Fields("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") 	= 1  
	mailCfg.Fields("http://schemas.microsoft.com/cdo/configuration/smtpusessl")      	= true 
	mailCfg.Fields("http://schemas.microsoft.com/cdo/configuration/sendusername")    	= Username
	mailCfg.Fields("http://schemas.microsoft.com/cdo/configuration/sendpassword")    	= Password
	mailCfg.Fields.Update

	mailObj.Send

end function

'----------------------------------------------------------------------------------------------
Function CheckMailServerParams() 
'----------------------------------------------------------------------------------------------
 
	CheckMailServerParams = true

	if Len(MailTo) < 1 OR Len(Username) < 1 OR Len(Password) < 1 OR Len(SmtpServer) < 1 then 
		
		CheckMailServerParams = false
		
		msgTxt = "The script is missing parameters for the mail-server!" + vbNewLine + vbNewLine 
		msgTxt = msgTxt + "Path: " + WScript.ScriptFullName + vbNewLine + vbNewLine
		msgTxt = msgTxt + "Please enter the values for MailTo, Username, Password and SmtpServer at the beginning of the script." + vbNewLine
		msgTxt = msgTxt + "Open the script now?"
						
		result = MsgBox (msgTxt, vbYesNo + vbQuestion, WScript.ScriptName)
		
		if result = vbYes then
			Set WshShell = WScript.CreateObject("WScript.Shell")
			WshShell.Run "%windir%\notepad " & WScript.ScriptFullName
			set WshShell = nothing
		end if
		
	end if
    
end function

'----------------------------------------------------------------------------------------------
Function InAbsence() 
'----------------------------------------------------------------------------------------------
 
	LockScreen 	= Params.Item("LockScreen")
	Presence 	= Params.Item("Presence")
	
	if LockScreen = "1" then Presence = "lockscreen" 

	'// PresenceManagmentStatus id=name
	'// 0=available,1=loggedout,2=away,3=brb,4=pause,5=busy,6=meeting,7=private,8=external,9=dnd,10=holiday,11=msg, 
	
	Select Case Presence
		Case "lockscreen", "loggedout", "away", "external"
			InAbsence = true
		Case Else
			InAbsence = false
	End Select	

    
end function

'----------------------------------------------------------------------------------------------
Function InTimeWindow() 
'----------------------------------------------------------------------------------------------
 
	InTimeWindow = true
	
	ThisWeekday = Weekday(Now)
	ThisHour = Hour(Time)
	
	'// Only on weekdays Mon - Fri
	if ( (ThisWeekday < 2) OR (ThisWeekday > 6) ) then InTimeWindow = false
	
	'// Only in the hours from 7:00 a.m. to 5:00 p.m
	if ( (ThisHour < 7) OR (ThisHour > 17) ) then InTimeWindow = false
		
end function

'----------------------------------------------------------------------------------------------
Function IsLocalDE() 
'----------------------------------------------------------------------------------------------
 
	LocalID = GetLocale '// 1031=Germany, 3079=Austria, 5127=Liechtenstein, 4103=Luxembourg, 2055=Switzerland
	
	Select Case LocalID
		Case 1031, 3079, 5127, 4103, 2055
			IsLocalDE = true
		Case Else
			IsLocalDE = false
	End Select	
    
end function

